SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-Test'!

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:34'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:15'!
basicSvnCommit: collectionOfPathesToTargets
 
	<primitive: 'svnCommit' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnGetHeadRevision: pathToTarget

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:18'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber
 
	<primitive: 'svnUpdateTargetsToRevisionByNumber' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets
 
	<primitive: 'svnUpdateTargetsToHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:56'!
basicSvnAdd: aPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:35'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:57'!
basicSvnCommit: collectionOfPathsToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:58'!
basicSvnGetHeadRevision: pathToTarget

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:19'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'converting' stamp: 'rt 2/5/2008 11:32'!
normalizePath: aString 

	| modifiedPath returnPath |
	modifiedPath := aString collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^(returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnAdd: aPath 

	self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 14:31'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self basicSvnCheckoutHeadRevisionFrom: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 14:56'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	self basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnCommit: aCollection 

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnCommit: commitArray! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 02:34'!
svnGetHeadRevision: aPath

	^ self basicSvnGetHeadRevision: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:25'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargets: updateArray toRevisionByNumber: revisionNumber! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:21'!
svnUpdateTargetsToHeadRevision: aCollection 

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargetsToHeadRevision: updateArray! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:08'!
basicSvnAdd: aPath 

	self executeViaOSProcessSynchronously: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:35'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:37'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self executeViaOSProcessSynchronously: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/13/2008 02:32'!
basicSvnCommit: collectionOfTargets 

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn commit' , targets , ' -m "log"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:49'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up -r', revisionNumber asString , targets! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:44'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up' , targets! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rkrk 2/13/2008 02:33'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'rt 2/7/2008 10:56'!
normalizePath: aPath

	^'"' , (super normalizePath: aPath) , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/21/2008 18:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/21/2008 18:55'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

Object subclass: #SVNElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/13/2008 01:18'!
theClass: aClass 
	^ (self new)
		theClass: aClass;
		yourself! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 12:46'!
= other

	^ self theClass = other theClass! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:09'!
contentsForFile

	self flag: #TODO. "Mapping method to contents of a file"
	self flag: #TODO. "Switch to streams entirely?"
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Instance side';
			nextPut: Character cr;
			nextPutAll: self theClass superclass name;
			nextPut: Character cr;
			nextPutAll: self theClass category;
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass instVarNames);
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass classVarNames);
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass poolDictionaryNames);
			nextPut: Character cr;
			 nextPutAll: 'Class side';
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass classSide instVarNames)].! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 2/13/2008 01:55'!
createClass: aClass withContents: contents

	self theClass: ((self extractSuperclassFrom: contents)
				subclass: aClass asSymbol
				instanceVariableNames: (self extractInstVarsFrom: contents)
				classVariableNames: (self extractClassVarsFrom: contents)
				poolDictionaries: (self extractPoolDictFrom: contents)
				category: (self extractCategoryFrom: contents)).
	self theClass classSide instanceVariableNames: (self extractMetaInstVarsFrom: contents).
	^ self theClass.! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/21/2008 16:40'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 13:58'!
extractCategoryFrom: contents
	
	^ contents lineNumber: 3.! !

!SVNClass methodsFor: 'extracting' stamp: 'test 2/12/2008 13:55'!
extractClassVarsFrom: contents
	
	^ contents lineNumber: 5! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:50'!
extractInstVarsFrom: contents
	
	^ contents lineNumber: 4.! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:53'!
extractMetaInstVarsFrom: contents
	
	^ contents lineNumber: 8! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:53'!
extractPoolDictFrom: contents
	
	^ contents lineNumber: 6! !

!SVNClass methodsFor: 'extracting' stamp: 'rkrk 2/13/2008 01:30'!
extractSuperclassFrom: contents
	
	^ self lookForClass: (contents lineNumber: 2)! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 12:46'!
hash

	^ self theClass hash! !

!SVNClass methodsFor: 'support' stamp: 'rkrk 2/13/2008 02:39'!
lookForClass: aString

	^ Smalltalk classNamed: aString.
	! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/13/2008 02:29'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theClass printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'read' stamp: 'rkrk 2/13/2008 01:23'!
readCommentFrom: aPath 
	
	self flag: #TODO. "String constant in code"
	self theClass comment: (self contentsOfFileNamed: aPath , FileDirectory slash , 'comment')! !

!SVNClass methodsFor: 'read' stamp: 'rkrk 2/13/2008 01:26'!
readElementFrom: aPath 
	| className contents |
	className := (FileDirectory on: aPath) localName.
	contents := self readFilePropertiesFrom: aPath.
	self
		createClass: className
		withContents: contents.
	self readCommentFrom: aPath.
	self
		readMethodsFrom: aPath , FileDirectory slash , 'instance'
		for: self theClass.
	self 
		readMethodsFrom: aPath , FileDirectory slash , 'class'
		for: self theClass classSide! !

!SVNClass methodsFor: 'read' stamp: 'test 2/12/2008 13:56'!
readFilePropertiesFrom: aPath 

	^ self contentsOfFileNamed: aPath , FileDirectory slash , 'properties'! !

!SVNClass methodsFor: 'read' stamp: 'rkrk 2/13/2008 02:07'!
readMethodsFrom: aPath for: anObject 

	(FileDirectory on: aPath) fileNames do: 
			[:each | SVNMethod
				readElementFrom: aPath , FileDirectory slash , each
				for: self theClass]! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass
	^ theClass! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass: aClass 
	theClass := aClass! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:40'!
writeClassMethodsTo: aPath 

	| path |
	path := aPath , 'class' , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeMethods: self theClass classSide methodDictionary
		to: path.! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:05'!
writeCommentTo: aPath 
	
	self
		write: self theClass comment
		to: aPath , FileDirectory slash , 'comment'! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:41'!
writeElementTo: aPath

	| path |
	path := aPath , FileDirectory slash , self theClass name , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeClassMethodsTo: path;
		writeInstanceMethodsTo: path;
		writeCommentTo: path;
		writePropertiesTo: path! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:41'!
writeInstanceMethodsTo: aPath

	| path |
	path := aPath , 'instance' , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeMethods: self theClass methodDictionary
		to: path! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:04'!
writeMethods: aMethDict to: aPath
	
	aMethDict do: [ :each | (SVNMethod for: each) writeElementTo: aPath].! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 01:41'!
writePropertiesTo: aPath

	self flag: #TODO "Hard coded string".
	self write: self contentsForFile to: aPath, FileDirectory slash, 'properties'! !

!SVNElement class methodsFor: 'instance creation' stamp: 'test 2/12/2008 13:34'!
readElementFrom: aPath
	^ (self new)
		readElementFrom: aPath;
		yourself! !

!SVNElement class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 12:50'!
readElementFrom: aPath for: aClass

	self flag: #TODO. "Necessary????"
	^ (self new)
		readElementFrom: aPath for: aClass;
		yourself! !

!SVNElement methodsFor: 'read' stamp: 'mu 2/7/2008 13:54'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNElement methodsFor: 'write' stamp: 'cop 2/12/2008 11:50'!
readElementFrom: aPath for: anObject 
	self subclassResponsibility! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
write: aString to: aPath

	(FileStream forceNewFileNamed: aPath )
		nextPutAll: aString;
		close.! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
writeElementTo: aPath

	self subclassResponsibility.! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/1/2008 02:20'!
for: aCompiledMethod 
	
	^ self methodReference: aCompiledMethod methodReference.! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 21:38'!
methodReference: aMethodReference 
	
	^ self new
		methodReference: aMethodReference;
		yourself! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 1/6/2008 22:07'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodClass = otherMethod methodClass &
			(self methodReference = otherMethod methodReference).! !

!SVNMethod methodsFor: 'modifying the system' stamp: 'rkrk 2/13/2008 02:38'!
compileMethodFrom: contents for: aClass

	| sourceCode selector |
	sourceCode := self extractSourceCodeFrom: contents.
	selector := aClass compile: sourceCode.
	^ aClass >> selector! !

!SVNMethod methodsFor: 'serializing' stamp: 'cop 2/12/2008 11:42'!
contentsForFile
	
	"Mapping method to contents of a file"
	self flag: #TODO.
	
	"For now: save the name of the category in the first line. The source code below."
	^ self methodReference category , String cr , self methodReference source! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/12/2008 11:42'!
extractCategoryFrom: contents

	^ contents lineNumber: 1! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/1/2008 23:23'!
extractClassFrom: contents

	| classStrings theClass |
	classStrings := (contents lineNumber: 1) substrings.
	theClass := Smalltalk at: classStrings first asSymbol.
	^ (classStrings last = 'class')
		ifTrue: [theClass class]
		ifFalse: [theClass].! !

!SVNMethod methodsFor: 'read' stamp: 'test 2/12/2008 12:06'!
extractSourceCodeFrom: aString 
	"Do not read the first line, it's the protocol"
	^ aString
		copyFrom: ( aString indexOf: Character cr ) + 1
		to: aString size! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/1/2008 17:51'!
extractTimeStampFrom: contents

	^ Smalltalk at: (contents lineNumber: 1) asSymbol! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'mu 2/7/2008 12:57'!
fileName

	| methodName |
	methodName := self selector asString.
	methodName replaceAll: $: with: $#.
	^ methodName! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/1/2008 11:38'!
hash

	^ self methodReference hash! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodClass
	
	^ self methodReference actualClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodReference
	
	 ^ methodReference! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/1/2008 02:59'!
methodReference: aMethodReference 
	
	methodReference := aMethodReference.! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/1/2008 11:24'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	self methodReference printOn: aStream.
	aStream nextPut: $).! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/13/2008 02:12'!
readElementFrom: aPath for: aClass

	| contents organization |
	contents := self contentsOfFileNamed: aPath.
	self methodReference: (self compileMethodFrom: contents for: aClass) methodReference.
	organization := aClass organization.
	organization classify: self selector
		under: (self extractCategoryFrom: contents)! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 2/1/2008 02:58'!
selector

	^ self methodReference methodSymbol! !

!SVNMethod methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:11'!
writeElementTo: aPath

	self
		write: self contentsForFile
		to: aPath , FileDirectory slash , self fileName.! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods projectName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 13:25'!
named: aString 
	
	^ self new
		projectName: aString;
		yourself.! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/21/2008 12:45'!
addClass: aClass

	^ self versionedClasses add: (SVNClass theClass: aClass)! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/2/2008 19:22'!
addMethod: aMethod 
	
	^ self versionedMethods add: (SVNMethod for: aMethod)! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 12:47'!
allVersionedMethods
	
	| methodsOfClasses |
	methodsOfClasses := self versionedClasses gather: [:svnClass |
		svnClass theClass methodDict collect: [:eachMethod | SVNMethod for: eachMethod]].
	^ self versionedMethods union: methodsOfClasses! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 13:25'!
projectName
	^ projectName! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 13:25'!
projectName: anObject
	projectName := anObject! !

!SVNProject methodsFor: 'serialization' stamp: 'rkrk 2/21/2008 13:31'!
storeInPath: aString 

	(FileDirectory on: aString) assureExistenceOfPath: self projectName.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:25'!
versionedMethods
	
	^ versionedMethods! !

Object subclass: #SVNFile
	instanceVariableNames: 'theName pathToFile content properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 18:38'!
named: aString pathToFile: pathName

	^ self new
		theName: aString;
		pathToFile: pathName
		yourself.! !

!SVNFile class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 18:48'!
named: aString pathToFile: pathName content: content

	^ (self named: aString pathToFile: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'initialize-release' stamp: 'rkrk 2/21/2008 19:24'!
initialize

	super initialize.
	self
		content: String new;
		properties: Dictionary new.! !

!SVNFile methodsFor: 'derived accessing' stamp: 'rkrk 2/21/2008 18:36'!
path

	^ self pathToFile , FileDirectory slash , self theName.! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 19:57'!
pathToFile

	^ pathToFile! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:35'!
pathToFile: anObject
	pathToFile := anObject! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 19:08'!
properties
	^ properties! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 19:08'!
properties: anObject
	properties := anObject! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 19:45'!
read
	
	self
		readContent;
		readProperties.! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 19:46'!
readContent

	(FileStream isAFileNamed: self path) ifFalse: [^ self].
	FileStream
		readOnlyFileNamed: self path
		do: [:stream | self content: stream contents].! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 19:55'!
readProperties
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."

	| contentsOfFile fullPath substrings key value |
	self flag: #TODO.
	fullPath := self pathToFile , FileDirectory slash , self theName , '_properties'.
	(FileStream isAFileNamed: fullPath) ifFalse: [^ self].
	FileStream
		readOnlyFileNamed: fullPath
		do: [:stream |
			contentsOfFile := stream contents.
			contentsOfFile linesDo: [:line |
				substrings := line subStrings: '-'.
				key := substrings first.
				value := substrings second.
				self properties at: key put: value]].! !

!SVNFile methodsFor: 'storing' stamp: 'rkrk 2/21/2008 19:10'!
store
	
	self
		storeContent;
		storeProperties.! !

!SVNFile methodsFor: 'storing' stamp: 'rkrk 2/21/2008 19:29'!
storeContent

	FileStream
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: self content ].! !

!SVNFile methodsFor: 'storing' stamp: 'rkrk 2/21/2008 19:47'!
storeProperties
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	
	| propertyFileName |
	self flag: #TODO.
	propertyFileName := self pathToFile , FileDirectory slash , self theName , '_properties'.
	FileStream
		forceNewFileNamed: propertyFileName
		do: [:stream | self properties keysAndValuesDo: [:key :value |
				stream
					nextPutAll: key;
					nextPut: $-;
					nextPutAll: value;
					nextPut: Character cr.].
				"Dirty. Delete last cr"
				stream size isZero not ifTrue: [
					stream truncate: stream size -1]	].! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 17:35'!
theName

	^ theName! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 17:33'!
theName: aString 

	theName := aString.! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/31/2008 05:20'!
answer17

	<primitive: 'answerSeventeen' module: 'PluginAnswering17'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:58'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:27'!
primSvnGetHeadRevision: target

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/12/2008 15:38'!
allSVNMethodsOfClass: aClass

	^ aClass methodDict collect: [:each | (SVNMethod for: each) fileName]! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/12/2008 15:39'!
classCommentForTests
	^ SVNDummy comment! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/21/2008 17:16'!
classPropertiesForTests

	| cr |
	cr := String cr.
	^ 'Instance side' , cr , SVNDummy superclass asString , cr ,
	self class category asString , cr ,
	(self createStringFromCollection: SVNDummy instVarNames) , cr ,
	(self createStringFromCollection: SVNDummy classVarNames) , cr , cr ,
	'Class side' , cr , 
	(self createStringFromCollection: SVNDummy class instVarNames)! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/12/2008 15:40'!
prepareReadTest
	| pathToClass |
	pathToClass := self pathForTests , FileDirectory slash , 'SVNTest'.
	(FileDirectory on: pathToClass) assureExistence.
	self
		inFile: pathToClass, FileDirectory slash , 'comment'
		write: self classCommentForTests.
	self
		inFile: pathToClass, FileDirectory slash , 'properties'
		write: self classPropertiesForTests.
	(FileDirectory on: pathToClass , FileDirectory slash, 'instance') assureExistence.	
	(FileDirectory on: pathToClass , FileDirectory slash, 'class') assureExistence.	! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/13/2008 01:18'!
prepareWriteTest
	| class path |
	class := SVNClass theClass: SVNDummy.
	path := self pathForTests , FileDirectory slash , class theClass name.
	self ensureThatFileNotExist: path.
	class writeElementTo: self pathForTests.
	^ path! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/13/2008 01:18'!
testAllClassMethodsExists
	| path |
	self flag: #TODO.
	path := self pathForTests , FileDirectory slash , 'SVNDummy' 
				, FileDirectory slash , 'class'.
	self ensureThatFileNotExist: path.
	(SVNClass theClass: SVNDummy) writeElementTo: self pathForTests.
	self assertThatFiles: (self allSVNMethodsOfClass: SVNDummy class)
		existsIn: path! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/13/2008 01:18'!
testAllInstanceMethodsExists
	| path |
	self flag: #TODO.
	path := self pathForTests , FileDirectory slash , 'SVNDummy' 
				, FileDirectory slash , 'instance'.
	self ensureThatFileNotExist: path.
	(SVNClass theClass: SVNDummy) writeElementTo: self pathForTests.
	self assertThatFiles: (self allSVNMethodsOfClass: SVNDummy) existsIn: path! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 17:31'!
testReadClass
	| class path |
	
	[self prepareReadTest.
	path := self createPathToFile: 'SVNTest' inDirectory: self pathForTests.
	class := (SVNClass readElementFrom: path) theClass.
	self assert: class name = 'SVNTest'.
	self assert: class superclass = Object.
	self assert: class category asString = 'SqueakSVN-Base-Test'.
	self assert: class instVarNames = #('i1' 'i2' ).
	self assert: class classVarNames = (Set with: #C1 with: #C2).
	self assert: class poolDictionaryNames isEmpty.
	self assert: class classSide instVarNames = #('IC1' 'IC2' )
	] ensure: [Smalltalk at: #SVNTest ifPresent: [:each |
		each removeFromSystemUnlogged]]! !

!SVNClassTest methodsFor: 'tests' stamp: 'test 2/12/2008 12:55'!
testWriteCommentFile
	| path commentContent |
	path := self prepareWriteTest.
	commentContent := (FileStream 
				readOnlyFileNamed: path , FileDirectory slash , 'comment') 
					contentsOfEntireFile.
	self assert: ((FileDirectory on: path) fileExists: 'comment').
	self assert: SVNDummy comment = commentContent! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 16:32'!
testWritePropertiesFile
	| path propertiesContent |
	path := self prepareWriteTest.
	propertiesContent := (FileStream 
				readOnlyFileNamed: path , FileDirectory slash , 'properties') 
					contentsOfEntireFile.
	self assert: ((FileDirectory on: path) fileExists: 'properties').
	self assert: self classPropertiesForTests  = propertiesContent! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: 'repositoryPath workingCopyPath fileToAdd sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:46'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/8/2008 00:54'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:42'!
testSVNAdd

	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 16:47'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory repositoryURLPath |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutHeadRevisionFrom: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 16:57'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory repositoryURLPath secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutRevisionByNumber: 1 from: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:42'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:13'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:08'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNClientExternalTest methodsFor: 'assert' stamp: 'rkrk 2/7/2008 15:44'!
assertWorkingCopyIncludesFile: fileName

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName).! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createRepository
	
	self assert: (FileDirectory isLegalFileName: repositoryPath).
	self deny: (FileDirectory on: repositoryPath , self slash) exists.
	
	self executeViaOSProcessSynchronously: 'svnadmin create ' , repositoryPath.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createWorkingCopy

	| repositoryURLPath |
	self assert: (FileDirectory on: repositoryPath , self slash) exists.
	self deny: (FileDirectory on: workingCopyPath) exists.
	
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURLPath , ' ' , workingCopyPath! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:44'!
setUp

	super setUp.
	repositoryPath := self pathForTests , self slash , 'repository'.
	workingCopyPath := self pathForTests , self slash , 'workingCopy'.
	self
		createRepository;
		createWorkingCopy.
	fileToAdd := 'testFile'.
	self createFile: workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSVNAdd

	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 16:47'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory repositoryURLPath |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutHeadRevisionFrom: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 17:00'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory repositoryURLPath secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutRevisionByNumber: 1 from: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 17:13'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 17:08'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

SVNClientExternalTest subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:44'!
setUp
	"self halt."

	super setUp.
	sut := SVNCApiClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:54'!
testBackslashToSlash

	| validPath |
	validPath := sut normalizePath: 'C:\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 11:17'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := sut normalizePath: 'C:\\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:59'!
testRemoveLastSlash

	| path |
	path := sut normalizePath: 'C:\test\test\'.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 19:38'!
testReadFileContents

	| sut fileName content fullPath |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		pathToFile: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self createPathToFile: fileName inDirectory: self pathForTests.
	self inFile: fullPath write: content.
	sut read.
	self assert: sut content = content.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 19:43'!
testReadFileProperties

	| sut fileName content fullPath propertyDict |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		pathToFile: self pathForTests.
	self assert: sut properties isEmpty.
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	content := 'key1-value1' , String cr , 'key2-value2'.
	fullPath := self createPathToFile: fileName , '_properties' inDirectory: self pathForTests.
	self inFile: fullPath write: content.
	sut read.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	self assert: sut properties = propertyDict.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 18:38'!
testStoreAsFile

	| sut fileName |
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		pathToFile: self pathForTests.
	sut store.
	self assertThatFiles: {fileName} existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 18:43'!
testStoreContent

	| sut fileName content |
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		pathToFile: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 19:18'!
testStoreProperties

	| sut fileName propertyDict expectedContent |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		pathToFile: self pathForTests.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	expectedContent := 'key1-value1' , String cr , 'key2-value2'.
	self
		assertThatFile: fileName , '_properties'
		inPath: self pathForTests
		hasContent: expectedContent.! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodTest methodsFor: 'running' stamp: 'rkrk 2/21/2008 18:58'!
tearDown

	super tearDown.
	SVNDummy methodDict
		at: #m2
		ifAbsent: [SVNDummy compile: SVNDummy sourceCodeForM2]! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'test 2/12/2008 12:07'!
testContentsToWrite
	| method expected result |
	method := SVNMethod for: SVNDummy >> #m1.
	expected := 'dummy methods
m1
	^ 1'.
	result := method contentsForFile.
	self assert: expected = result! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'cop 2/12/2008 11:57'!
testContentsToWriteCaseMetaClass
	| method expected result |
	method := SVNMethod for: SVNDummy class >> #m3.
	expected := 'dummy
m3

	^ 3'.
	result := method contentsForFile.
	self assert: expected = result! !

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 18:58'!
testEquals
	| methodBlock method1 method2 |
	methodBlock := [SVNMethod methodReference: (SVNDummy >> #m1) methodReference].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'mu 2/7/2008 16:54'!
testExtractMetaClass
	| source method result expected |
	method := SVNMethod new.
	source := 'SVNDummy class' , String cr , 'dummy' , String cr , 'm4 ^ 4'.
	result := method extractClassFrom: source.
	expected := SVNDummy class.
	self assert: result = expected! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/21/2008 18:58'!
testRead

	| method expectedSource methodName fileName |
	methodName := 'm2'.
	expectedSource := 'dummy methods' , String cr 
				, SVNDummy sourceCodeForM2.
	SVNDummy removeSelector: methodName asSymbol.
	fileName := self pathForTests , FileDirectory slash , methodName.
	self inFile: fileName write: expectedSource.
	method := SVNMethod readElementFrom: fileName for: SVNDummy.
	self assert: expectedSource = method contentsForFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/21/2008 18:54'!
testWrite
	| method expected |
	method := SVNMethod for: SVNDummy >> #methodWithSpecialCharacter:.
	"self ensureThatFileNotExist: fileName." "Is this necessary?"
	method writeElementTo: self pathForTests.
	expected := 'dummy methods
methodWithSpecialCharacter: aString
	^ aString'.
	self assertThatFile: method fileName inPath: self pathForTests hasContent: expected.
	"self ensureThatFileNotExist: fileName" "Why not in tear down?"! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'cop 2/12/2008 11:58'!
testWriteRead
	| method fileName readMethod |
	method := SVNMethod for: SVNDummy >> #m1.
	fileName := self createPathToFile: method fileName
				inDirectory: self pathForTests.
	self ensureThatFileNotExist: fileName.
	method writeElementTo: self pathForTests.
	readMethod := SVNMethod readElementFrom: fileName for: SVNDummy.
	self assert: method = readMethod.
	self ensureThatFileNotExist: fileName! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 13:31'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject projectName).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 12:45'!
testAddClass
	| sut aClass methodsOfClass result |
	sut := SVNProject new.
	aClass := SVNDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass theClass: aClass)).
	methodsOfClass := aClass methodDict collect: [ : ea | SVNMethod for: ea ].
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet! !

!SVNProjectTest methodsFor: 'tests' stamp: 'mu 2/7/2008 16:56'!
testAddMethod
	| sut aMethod svnMethod |
	sut := SVNProject new.
	aMethod := SVNDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod methodClass = aMethod methodClass.
	self assert: svnMethod selector = aMethod selector! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 13:37'!
testMappingToFileSystem01

	| sut |
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut storeInPath: self pathForTests.
	self assertExistanceOfProject: sut in: self pathForTests.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 13:37'!
testMappingToFileSystem02

	| sut |
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut storeInPath: self pathForTests.
	self assertExistanceOfProject: sut in: self pathForTests.! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 19:16'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent

	| fullPath actualContent |
	fullPath := self createPathToFile: fileName inDirectory: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent.! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 17:40'!
assertThatFiles: fileNames existsIn: path

	fileNames  do: [:each | self assert: ((FileDirectory on: path) fileExists: each)] .! !

!SVNTestCase methodsFor: 'write files' stamp: 'rkrk 2/1/2008 15:34'!
createPathToFile: filename inDirectory: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/21/2008 16:41'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:30'!
ensureThatFileNotExist: fileName

	FileDirectory deleteFilePath: fileName! !

!SVNTestCase methodsFor: 'OSProcess' stamp: 'rkrk 2/7/2008 13:51'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNTestCase methodsFor: 'write files' stamp: 'test 2/12/2008 12:36'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.

	! !

!SVNTestCase methodsFor: 'default' stamp: 'cop 2/12/2008 11:24'!
pathForTests

	"If you touch the path, reset it before commit!!'"
	^ SmalltalkImage current imagePath , FileDirectory slash , 'svnTests'! !

!SVNTestCase methodsFor: 'read files' stamp: 'cop 2/5/2008 11:33'!
readFileFrom: aDir fileName: aString

	| stream contents |
	stream := aDir oldFileNamed: aString.
	contents := stream contents.
	stream close.
	^contents! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/12/2008 14:59'!
setUp

	super setUp.
	(FileDirectory on: self pathForTests) assureExistence.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:24'!
slash

	^ FileDirectory slash! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/3/2008 22:43'!
tearDown

	super tearDown.
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [(FileDirectory on: self pathForTests) recursiveDelete]
		ifTrue: [self executeViaOSProcessSynchronously: 'delete_svnTests.bat'].! !
